# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/Adelus clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "Adelus requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/Adelus build
## ---------------------------------------------------------------------------

set(Adelus_CXX_COMPILER "/usr/bin/g++")

set(Adelus_C_COMPILER "/usr/bin/gcc")

set(Adelus_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(Adelus_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/Adelus build
## ---------------------------------------------------------------------------

## Give the build type
set(Adelus_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(Adelus_CXX_FLAGS [[ ]])

set(Adelus_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fPIC -w -fopenmp ]])

set(Adelus_Fortran_FLAGS [[ ]])
# Deprecated
set(Adelus_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(Adelus_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(Adelus_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(Adelus_BUILD_SHARED_LIBS "ON")

set(Adelus_LINKER /usr/bin/ld)
set(Adelus_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(Adelus_INSTALL_DIR "/usr")

## List of package include dirs
set(Adelus_INCLUDE_DIRS "")

## List of package library paths
set(Adelus_LIBRARY_DIRS "")

## List of package libraries
set(Adelus_LIBRARIES "Adelus::zadelus;KokkosKernels::kokkoskernels;KokkosSimd::kokkossimd;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(Adelus_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(Adelus_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(Adelus_TPL_LIBRARIES "DLlib::all_libs;SuperLU::all_libs;LAPACK::all_libs;BLAS::all_libs;Pthread::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(Adelus_MPI_LIBRARIES "")
set(Adelus_MPI_LIBRARY_DIRS "")
set(Adelus_MPI_INCLUDE_DIRS "")
set(Adelus_MPI_EXEC "")
set(Adelus_MPI_EXEC_MAX_NUMPROCS "")
set(Adelus_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(Adelus_PACKAGE_LIST "Adelus;KokkosKernels;Kokkos;KokkosSimd;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(Adelus_TPL_LIST "DLlib;SuperLU;LAPACK;BLAS;Pthread")

# Enables/Disables for upstream package dependencies
set(Adelus_ENABLE_Kokkos ON)
set(Adelus_ENABLE_KokkosKernels ON)
set(Adelus_ENABLE_BLAS ON)

# Exported cache variables
set(Adelus_ENABLE_ZCPLX "ON")
set(ZCPLX "ON")
set(Adelus_ENABLE_SCPLX "OFF")
set(SCPLX "OFF")
set(Adelus_ENABLE_DREAL "OFF")
set(DREAL "OFF")
set(Adelus_ENABLE_SREAL "OFF")
set(SREAL "OFF")
set(Adelus_ENABLE_TIMING "OFF")
set(GET_TIMING "OFF")
set(Adelus_ENABLE_HOSTPINNEDMEM "ON")
set(ADELUS_HOST_PINNED_MEM_MPI "ON")
set(Adelus_ENABLE_USEDEEPCOPY "OFF")
set(USE_DEEPCOPY "OFF")
set(Adelus_ENABLE_PRINTSTATUS "OFF")
set(PRINT_STATUS "OFF")

# Include configuration of dependent packages
if (NOT TARGET Kokkos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Kokkos/KokkosConfig.cmake")
endif()
if (NOT TARGET KokkosKernels::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosKernels/KokkosKernelsConfig.cmake")
endif()
if (NOT TARGET BLAS::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Trilinos/external_packages/BLAS/BLASConfig.cmake")
endif()

# Import Adelus targets
include("${CMAKE_CURRENT_LIST_DIR}/AdelusTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(Adelus_EXPORTED_PACKAGE_LIBS_NAMES "zadelus")

foreach(libname IN LISTS Adelus_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE Adelus::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'Adelus::${libname}', or better yet,"
      " 'Adelus::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'Adelus'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'Adelus_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
