# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/MueLu clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "MueLu requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/MueLu build
## ---------------------------------------------------------------------------

set(MueLu_CXX_COMPILER "/usr/bin/g++")

set(MueLu_C_COMPILER "/usr/bin/gcc")

set(MueLu_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(MueLu_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/MueLu build
## ---------------------------------------------------------------------------

## Give the build type
set(MueLu_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(MueLu_CXX_FLAGS [[ ]])

set(MueLu_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fPIC -w -fopenmp ]])

set(MueLu_Fortran_FLAGS [[ ]])
# Deprecated
set(MueLu_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(MueLu_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(MueLu_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(MueLu_BUILD_SHARED_LIBS "ON")

set(MueLu_LINKER /usr/bin/ld)
set(MueLu_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(MueLu_INSTALL_DIR "/usr")

## List of package include dirs
set(MueLu_INCLUDE_DIRS "")

## List of package library paths
set(MueLu_LIBRARY_DIRS "")

## List of package libraries
set(MueLu_LIBRARIES "MueLu::muelu-adapters;MueLu::muelu;Intrepid2::intrepid2;Teko::teko;Stratimikos::stratimikos;Stratimikos::stratimikosbelos;Stratimikos::stratimikosamesos2;Stratimikos::stratimikosaztecoo;Stratimikos::stratimikosamesos;Stratimikos::stratimikosml;Stratimikos::stratimikosifpack;Ifpack2::ifpack2-adapters;Ifpack2::ifpack2;Anasazi::anasazitpetra;Anasazi::ModeLaplace;Anasazi::anasaziepetra;Anasazi::anasazi;Amesos2::amesos2;ShyLU_NodeTacho::tacho;ShyLU_NodeHTS::shylu_nodehts;Belos::belosxpetra;Belos::belostpetra;Belos::belosepetra;Belos::belos;ML::ml;Ifpack::ifpack;Zoltan2Core::zoltan2;Amesos::amesos;Galeri::galeri-xpetra;Galeri::galeri-epetra;AztecOO::aztecoo;Isorropia::isorropia;Xpetra::xpetra-sup;Xpetra::xpetra;ThyraTpetraAdapters::thyratpetra;ThyraEpetraExtAdapters::thyraepetraext;ThyraEpetraAdapters::thyraepetra;ThyraCore::thyracore;TrilinosSS::trilinosss;TpetraCore::tpetraext;TpetraCore::tpetrainout;TpetraCore::tpetra;TpetraCore::tpetraclassic;TpetraTSQR::kokkostsqr;EpetraExt::epetraext;Triutils::triutils;Shards::shards;Zoltan::zoltan;Zoltan::simpi;Epetra::epetra;Sacado::sacado;RTOp::rtop;KokkosKernels::kokkoskernels;TeuchosKokkosComm::teuchoskokkoscomm;TeuchosKokkosCompat::teuchoskokkoscompat;TeuchosRemainder::teuchosremainder;TeuchosNumerics::teuchosnumerics;TeuchosComm::teuchoscomm;TeuchosParameterList::teuchosparameterlist;TeuchosParser::teuchosparser;TeuchosCore::teuchoscore;KokkosSimd::kokkossimd;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(MueLu_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(MueLu_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(MueLu_TPL_LIBRARIES "DLlib::all_libs;Eigen::all_libs;AMD::all_libs;UMFPACK::all_libs;SuperLU::all_libs;HDF5::all_libs;Zlib::all_libs;Scotch::all_libs;Boost::all_libs;LAPACK::all_libs;BLAS::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(MueLu_MPI_LIBRARIES "")
set(MueLu_MPI_LIBRARY_DIRS "")
set(MueLu_MPI_INCLUDE_DIRS "")
set(MueLu_MPI_EXEC "")
set(MueLu_MPI_EXEC_MAX_NUMPROCS "")
set(MueLu_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(MueLu_PACKAGE_LIST "MueLu;Intrepid2;Teko;Stratimikos;Ifpack2;Anasazi;Amesos2;ShyLU_NodeTacho;ShyLU_NodeHTS;Belos;ML;Ifpack;Zoltan2Core;Amesos;Galeri;AztecOO;Isorropia;Xpetra;Thyra;ThyraTpetraAdapters;ThyraEpetraExtAdapters;ThyraEpetraAdapters;ThyraCore;TrilinosSS;Tpetra;TpetraCore;TpetraTSQR;EpetraExt;Triutils;Shards;Zoltan;Epetra;Sacado;RTOp;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;Kokkos;KokkosSimd;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(MueLu_TPL_LIST "DLlib;Eigen;AMD;UMFPACK;SuperLU;HDF5;Zlib;Scotch;Boost;LAPACK;BLAS;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(MueLu_ENABLE_Teuchos ON)
set(MueLu_ENABLE_Xpetra ON)
set(MueLu_ENABLE_KokkosCore ON)
set(MueLu_ENABLE_KokkosContainers ON)
set(MueLu_ENABLE_KokkosKernels ON)
set(MueLu_ENABLE_Amesos ON)
set(MueLu_ENABLE_Amesos2 ON)
set(MueLu_ENABLE_Belos ON)
set(MueLu_ENABLE_Epetra ON)
set(MueLu_ENABLE_EpetraExt ON)
set(MueLu_ENABLE_Teko ON)
set(MueLu_ENABLE_Ifpack ON)
set(MueLu_ENABLE_Ifpack2 ON)
set(MueLu_ENABLE_Intrepid2 ON)
set(MueLu_ENABLE_ML ON)
set(MueLu_ENABLE_Tpetra ON)
set(MueLu_ENABLE_Zoltan ON)
set(MueLu_ENABLE_Zoltan2Core ON)
set(MueLu_ENABLE_Stratimikos ON)
set(MueLu_ENABLE_Thyra ON)
set(MueLu_ENABLE_ThyraTpetraAdapters ON)
set(MueLu_ENABLE_Isorropia ON)
set(MueLu_ENABLE_BLAS ON)
set(MueLu_ENABLE_LAPACK ON)
set(MueLu_ENABLE_Boost ON)
set(MueLu_ENABLE_MATLAB OFF)
set(MueLu_ENABLE_AmgX OFF)
set(MueLu_ENABLE_CGAL OFF)
set(MueLu_ENABLE_ViennaCL OFF)
set(MueLu_ENABLE_MKL OFF)
set(MueLu_ENABLE_Avatar OFF)
set(MueLu_ENABLE_CUSPARSE OFF)
set(MueLu_ENABLE_MAGMASparse OFF)
set(MueLu_ENABLE_mlpack OFF)

# Exported cache variables
set(MueLu_ENABLE_EXPLICIT_INSTANTIATION "ON")
set(HAVE_MUELU_EXPLICIT_INSTANTIATION "ON")
set(MueLu_ENABLE_DEBUG "OFF")
set(HAVE_MUELU_DEBUG "OFF")
set(MueLu_ENABLE_DEPRECATED_CODE "YES")
set(HAVE_MUELU_DEPRECATED_CODE "ON")
set(MueLu_ENABLE_DEPRECATED_TESTS "NO")
set(HAVE_MUELU_DEPRECATED_TESTS "OFF")
set(MueLu_ENABLE_Experimental "NO")
set(HAVE_MUELU_EXPERIMENTAL "OFF")
set(MueLu_ENABLE_ADDITIVE_VARIANT "NO")
set(HAVE_MUELU_ADDITIVE_VARIANT "OFF")
set(MueLu_ENABLE_REGION_SPLITTING "NO")
set(HAVE_MUELU_REGION_SPLITTING "OFF")
set(MueLu_ENABLE_Tutorial "MueLu_ENABLE_Tutorial_DEFAULT")
set(MueLu_ENABLE_SPLIT_ETI_CPP_FILES "NO")
set(HAVE_MUELU_SPLIT_ETI_CPP_FILES "OFF")
set(MueLu_ENABLE_PROFILING "OFF")
set(HAVE_MUELU_PROFILING "OFF")
set(MueLu_ENABLE_GOOGLE_PERFTOOLS "OFF")
set(HAVE_MUELU_GOOGLE_PERFTOOLS "OFF")
set(MueLu_ENABLE_Boost_for_real "OFF")
set(HAVE_MUELU_BOOST_FOR_REAL "OFF")
set(MueLu_ENABLE_Kokkos_Refactor "ON")
set(HAVE_MUELU_KOKKOS_REFACTOR "ON")
set(MueLu_ENABLE_ML_MMM "OFF")
set(HAVE_MUELU_ML_MMM "OFF")

# Include configuration of dependent packages
if (NOT TARGET Teuchos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Teuchos/TeuchosConfig.cmake")
endif()
if (NOT TARGET Xpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Xpetra/XpetraConfig.cmake")
endif()
if (NOT TARGET KokkosCore::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosCore/KokkosCoreConfig.cmake")
endif()
if (NOT TARGET KokkosContainers::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosContainers/KokkosContainersConfig.cmake")
endif()
if (NOT TARGET KokkosKernels::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosKernels/KokkosKernelsConfig.cmake")
endif()
if (NOT TARGET Amesos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Amesos/AmesosConfig.cmake")
endif()
if (NOT TARGET Amesos2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Amesos2/Amesos2Config.cmake")
endif()
if (NOT TARGET Belos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Belos/BelosConfig.cmake")
endif()
if (NOT TARGET Epetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Epetra/EpetraConfig.cmake")
endif()
if (NOT TARGET EpetraExt::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../EpetraExt/EpetraExtConfig.cmake")
endif()
if (NOT TARGET Teko::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Teko/TekoConfig.cmake")
endif()
if (NOT TARGET Ifpack::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Ifpack/IfpackConfig.cmake")
endif()
if (NOT TARGET Ifpack2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Ifpack2/Ifpack2Config.cmake")
endif()
if (NOT TARGET Intrepid2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Intrepid2/Intrepid2Config.cmake")
endif()
if (NOT TARGET ML::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ML/MLConfig.cmake")
endif()
if (NOT TARGET Tpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
endif()
if (NOT TARGET Zoltan::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Zoltan/ZoltanConfig.cmake")
endif()
if (NOT TARGET Zoltan2Core::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Zoltan2Core/Zoltan2CoreConfig.cmake")
endif()
if (NOT TARGET Stratimikos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Stratimikos/StratimikosConfig.cmake")
endif()
if (NOT TARGET Thyra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Thyra/ThyraConfig.cmake")
endif()
if (NOT TARGET ThyraTpetraAdapters::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ThyraTpetraAdapters/ThyraTpetraAdaptersConfig.cmake")
endif()
if (NOT TARGET Isorropia::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Isorropia/IsorropiaConfig.cmake")
endif()
if (NOT TARGET BLAS::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Trilinos/external_packages/BLAS/BLASConfig.cmake")
endif()
if (NOT TARGET LAPACK::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Trilinos/external_packages/LAPACK/LAPACKConfig.cmake")
endif()
if (NOT TARGET Boost::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Trilinos/external_packages/Boost/BoostConfig.cmake")
endif()

# Import MueLu targets
include("${CMAKE_CURRENT_LIST_DIR}/MueLuTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(MueLu_EXPORTED_PACKAGE_LIBS_NAMES "muelu;muelu-adapters")

foreach(libname IN LISTS MueLu_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE MueLu::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'MueLu::${libname}', or better yet,"
      " 'MueLu::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'MueLu'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'MueLu_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
