# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/SEACAS clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "SEACAS requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/SEACAS build
## ---------------------------------------------------------------------------

set(SEACAS_CXX_COMPILER "/usr/bin/g++")

set(SEACAS_C_COMPILER "/usr/bin/gcc")

set(SEACAS_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(SEACAS_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/SEACAS build
## ---------------------------------------------------------------------------

## Give the build type
set(SEACAS_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(SEACAS_CXX_FLAGS [[ ]])

set(SEACAS_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fPIC -w -fopenmp ]])

set(SEACAS_Fortran_FLAGS [[ ]])
# Deprecated
set(SEACAS_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(SEACAS_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(SEACAS_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(SEACAS_BUILD_SHARED_LIBS "ON")

set(SEACAS_LINKER /usr/bin/ld)
set(SEACAS_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(SEACAS_INSTALL_DIR "/usr")

## List of package include dirs
set(SEACAS_INCLUDE_DIRS "")

## List of package library paths
set(SEACAS_LIBRARY_DIRS "")

## List of package libraries
set(SEACAS_LIBRARIES "SEACASMapvarlib::mapvarlib;SEACASFastq::fastqlib;SEACASBlot::blotlib;SEACASPLT::plt;SEACASSVDI::svdi_cgi;SEACASSVDI::svdi_cdr;SEACASSuplibCpp::suplib_cpp;SEACASSuplibC::suplib_c;SEACASSuplib::suplib;SEACASSupes::supes;SEACASAprepro_lib::aprepro_lib;SEACASChaco::chaco;SEACASIoss::io_info_lib;SEACASIoss::Ionit;SEACASIoss::Iotr;SEACASIoss::Iohb;SEACASIoss::Iogs;SEACASIoss::Iotm;SEACASIoss::Iogn;SEACASIoss::Iovs;SEACASIoss::Iopg;SEACASIoss::Ioex;SEACASIoss::Ioss;SEACASNemesis::nemesis;SEACASExoIIv2for32::exoIIv2for32;SEACASExodus_for::exodus_for;SEACASExodus::exodus;Pamgen::pamgen_extras;Pamgen::pamgen;Zoltan::zoltan;Zoltan::simpi;KokkosSimd::kokkossimd;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(SEACAS_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(SEACAS_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(SEACAS_TPL_LIBRARIES "DLlib::all_libs;X11::all_libs;Matio::all_libs;Netcdf::all_libs;HDF5::all_libs;Zlib::all_libs;Scotch::all_libs;Boost::all_libs;Pthread::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(SEACAS_MPI_LIBRARIES "")
set(SEACAS_MPI_LIBRARY_DIRS "")
set(SEACAS_MPI_INCLUDE_DIRS "")
set(SEACAS_MPI_EXEC "")
set(SEACAS_MPI_EXEC_MAX_NUMPROCS "")
set(SEACAS_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(SEACAS_PACKAGE_LIST "SEACASEx2ex1v2;SEACASTxtexo;SEACASSlice;SEACASNumbers;SEACASNemspread;SEACASNemslice;SEACASZellij;SEACASNas2exo;SEACASMat2exo;SEACASMapvar-kd;SEACASMapvar;SEACASMapvarlib;SEACASExplore;SEACASGrepos;SEACASGenshell;SEACASGen3D;SEACASGjoin;SEACASFastq;SEACASEx1ex2v2;SEACASExo_format;SEACASExotxt;SEACASExomatlab;SEACASExodiff;SEACASExo2mat;SEACASCpup;SEACASEpu;SEACASEjoin;SEACASConjoin;SEACASBlot;SEACASAprepro;SEACASAlgebra;SEACASPLT;SEACASSVDI;SEACASSuplibCpp;SEACASSuplibC;SEACASSuplib;SEACASSupes;SEACASAprepro_lib;SEACASChaco;SEACASIoss;SEACASNemesis;SEACASExoIIv2for32;SEACASExodus_for;SEACASExodus;Pamgen;Zoltan;Kokkos;KokkosSimd;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(SEACAS_TPL_LIST "DLlib;X11;Matio;Netcdf;HDF5;Zlib;Scotch;Boost;Pthread")

# Enables/Disables for upstream package dependencies
set(SEACAS_ENABLE_SEACASExodus ON)
set(SEACAS_ENABLE_SEACASIoss ON)
set(SEACAS_ENABLE_SEACASExodus_for ON)
set(SEACAS_ENABLE_SEACASExoIIv2for32 ON)
set(SEACAS_ENABLE_SEACASNemesis ON)
set(SEACAS_ENABLE_SEACASChaco ON)
set(SEACAS_ENABLE_SEACASAprepro_lib ON)
set(SEACAS_ENABLE_SEACASSupes ON)
set(SEACAS_ENABLE_SEACASSuplib ON)
set(SEACAS_ENABLE_SEACASSuplibC ON)
set(SEACAS_ENABLE_SEACASSuplibCpp ON)
set(SEACAS_ENABLE_SEACASSVDI ON)
set(SEACAS_ENABLE_SEACASPLT ON)
set(SEACAS_ENABLE_SEACASAlgebra ON)
set(SEACAS_ENABLE_SEACASAprepro ON)
set(SEACAS_ENABLE_SEACASBlot ON)
set(SEACAS_ENABLE_SEACASConjoin ON)
set(SEACAS_ENABLE_SEACASEjoin ON)
set(SEACAS_ENABLE_SEACASEpu ON)
set(SEACAS_ENABLE_SEACASCpup ON)
set(SEACAS_ENABLE_SEACASExo2mat ON)
set(SEACAS_ENABLE_SEACASExodiff ON)
set(SEACAS_ENABLE_SEACASExomatlab ON)
set(SEACAS_ENABLE_SEACASExotxt ON)
set(SEACAS_ENABLE_SEACASExo_format ON)
set(SEACAS_ENABLE_SEACASEx1ex2v2 ON)
set(SEACAS_ENABLE_SEACASExotec2 OFF)
set(SEACAS_ENABLE_SEACASFastq ON)
set(SEACAS_ENABLE_SEACASGjoin ON)
set(SEACAS_ENABLE_SEACASGen3D ON)
set(SEACAS_ENABLE_SEACASGenshell ON)
set(SEACAS_ENABLE_SEACASGrepos ON)
set(SEACAS_ENABLE_SEACASExplore ON)
set(SEACAS_ENABLE_SEACASMapvarlib ON)
set(SEACAS_ENABLE_SEACASMapvar ON)
set(SEACAS_ENABLE_SEACASMapvar-kd ON)
set(SEACAS_ENABLE_SEACASMat2exo ON)
set(SEACAS_ENABLE_SEACASNas2exo ON)
set(SEACAS_ENABLE_SEACASZellij ON)
set(SEACAS_ENABLE_SEACASNemslice ON)
set(SEACAS_ENABLE_SEACASNemspread ON)
set(SEACAS_ENABLE_SEACASNumbers ON)
set(SEACAS_ENABLE_SEACASSlice ON)
set(SEACAS_ENABLE_SEACASTxtexo ON)
set(SEACAS_ENABLE_SEACASEx2ex1v2 ON)
set(SEACAS_ENABLE_MPI OFF)

# Exported cache variables
set(SEACAS_ENABLE_DEBUG "OFF")
set(HAVE_SEACAS_DEBUG "OFF")
set(SEACASExodus_ENABLE_THREADSAFE "OFF")
set(EXODUS_THREADSAFE "OFF")
set(SEACASExodus_ENABLE_STATIC "OFF")
set(EXODUS_STATIC "OFF")
set(SEACASExodus_ENABLE_SHARED "OFF")
set(EXODUS_SHARED "OFF")
set(SEACASIoss_ENABLE_THREADSAFE "OFF")
set(IOSS_THREADSAFE "OFF")

# Include configuration of dependent packages
if (NOT TARGET SEACASExodus::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExodus/SEACASExodusConfig.cmake")
endif()
if (NOT TARGET SEACASIoss::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASIoss/SEACASIossConfig.cmake")
endif()
if (NOT TARGET SEACASExodus_for::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExodus_for/SEACASExodus_forConfig.cmake")
endif()
if (NOT TARGET SEACASExoIIv2for32::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExoIIv2for32/SEACASExoIIv2for32Config.cmake")
endif()
if (NOT TARGET SEACASNemesis::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASNemesis/SEACASNemesisConfig.cmake")
endif()
if (NOT TARGET SEACASChaco::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASChaco/SEACASChacoConfig.cmake")
endif()
if (NOT TARGET SEACASAprepro_lib::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASAprepro_lib/SEACASAprepro_libConfig.cmake")
endif()
if (NOT TARGET SEACASSupes::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASSupes/SEACASSupesConfig.cmake")
endif()
if (NOT TARGET SEACASSuplib::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASSuplib/SEACASSuplibConfig.cmake")
endif()
if (NOT TARGET SEACASSuplibC::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASSuplibC/SEACASSuplibCConfig.cmake")
endif()
if (NOT TARGET SEACASSuplibCpp::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASSuplibCpp/SEACASSuplibCppConfig.cmake")
endif()
if (NOT TARGET SEACASSVDI::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASSVDI/SEACASSVDIConfig.cmake")
endif()
if (NOT TARGET SEACASPLT::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASPLT/SEACASPLTConfig.cmake")
endif()
if (NOT TARGET SEACASAlgebra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASAlgebra/SEACASAlgebraConfig.cmake")
endif()
if (NOT TARGET SEACASAprepro::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASAprepro/SEACASApreproConfig.cmake")
endif()
if (NOT TARGET SEACASBlot::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASBlot/SEACASBlotConfig.cmake")
endif()
if (NOT TARGET SEACASConjoin::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASConjoin/SEACASConjoinConfig.cmake")
endif()
if (NOT TARGET SEACASEjoin::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASEjoin/SEACASEjoinConfig.cmake")
endif()
if (NOT TARGET SEACASEpu::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASEpu/SEACASEpuConfig.cmake")
endif()
if (NOT TARGET SEACASCpup::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASCpup/SEACASCpupConfig.cmake")
endif()
if (NOT TARGET SEACASExo2mat::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExo2mat/SEACASExo2matConfig.cmake")
endif()
if (NOT TARGET SEACASExodiff::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExodiff/SEACASExodiffConfig.cmake")
endif()
if (NOT TARGET SEACASExomatlab::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExomatlab/SEACASExomatlabConfig.cmake")
endif()
if (NOT TARGET SEACASExotxt::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExotxt/SEACASExotxtConfig.cmake")
endif()
if (NOT TARGET SEACASExo_format::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExo_format/SEACASExo_formatConfig.cmake")
endif()
if (NOT TARGET SEACASEx1ex2v2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASEx1ex2v2/SEACASEx1ex2v2Config.cmake")
endif()
if (NOT TARGET SEACASFastq::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASFastq/SEACASFastqConfig.cmake")
endif()
if (NOT TARGET SEACASGjoin::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASGjoin/SEACASGjoinConfig.cmake")
endif()
if (NOT TARGET SEACASGen3D::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASGen3D/SEACASGen3DConfig.cmake")
endif()
if (NOT TARGET SEACASGenshell::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASGenshell/SEACASGenshellConfig.cmake")
endif()
if (NOT TARGET SEACASGrepos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASGrepos/SEACASGreposConfig.cmake")
endif()
if (NOT TARGET SEACASExplore::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExplore/SEACASExploreConfig.cmake")
endif()
if (NOT TARGET SEACASMapvarlib::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASMapvarlib/SEACASMapvarlibConfig.cmake")
endif()
if (NOT TARGET SEACASMapvar::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASMapvar/SEACASMapvarConfig.cmake")
endif()
if (NOT TARGET SEACASMapvar-kd::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASMapvar-kd/SEACASMapvar-kdConfig.cmake")
endif()
if (NOT TARGET SEACASMat2exo::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASMat2exo/SEACASMat2exoConfig.cmake")
endif()
if (NOT TARGET SEACASNas2exo::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASNas2exo/SEACASNas2exoConfig.cmake")
endif()
if (NOT TARGET SEACASZellij::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASZellij/SEACASZellijConfig.cmake")
endif()
if (NOT TARGET SEACASNemslice::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASNemslice/SEACASNemsliceConfig.cmake")
endif()
if (NOT TARGET SEACASNemspread::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASNemspread/SEACASNemspreadConfig.cmake")
endif()
if (NOT TARGET SEACASNumbers::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASNumbers/SEACASNumbersConfig.cmake")
endif()
if (NOT TARGET SEACASSlice::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASSlice/SEACASSliceConfig.cmake")
endif()
if (NOT TARGET SEACASTxtexo::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASTxtexo/SEACASTxtexoConfig.cmake")
endif()
if (NOT TARGET SEACASEx2ex1v2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASEx2ex1v2/SEACASEx2ex1v2Config.cmake")
endif()

# Import SEACAS targets
include("${CMAKE_CURRENT_LIST_DIR}/SEACASTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(SEACAS_EXPORTED_PACKAGE_LIBS_NAMES "exodus;exodus_for;exoIIv2for32;nemesis;Ioex;Iopg;Iovs;Iogn;Iotm;Iogs;Iohb;Iotr;Ionit;io_info_lib;Ioss;chaco;aprepro_lib;supes;suplib;suplib_c;suplib_cpp;svdi_cdr;svdi_cgi;plt;blotlib;fastqlib;mapvarlib")

foreach(libname IN LISTS SEACAS_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE SEACAS::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'SEACAS::${libname}', or better yet,"
      " 'SEACAS::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'SEACAS'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'SEACAS_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
