# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/SEACASAprepro_lib clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "SEACASAprepro_lib requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/SEACASAprepro_lib build
## ---------------------------------------------------------------------------

set(SEACASAprepro_lib_CXX_COMPILER "/usr/bin/g++")

set(SEACASAprepro_lib_C_COMPILER "/usr/bin/gcc")

set(SEACASAprepro_lib_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(SEACASAprepro_lib_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/SEACASAprepro_lib build
## ---------------------------------------------------------------------------

## Give the build type
set(SEACASAprepro_lib_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(SEACASAprepro_lib_CXX_FLAGS [[ ]])

set(SEACASAprepro_lib_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fPIC -w -fopenmp ]])

set(SEACASAprepro_lib_Fortran_FLAGS [[ ]])
# Deprecated
set(SEACASAprepro_lib_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(SEACASAprepro_lib_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(SEACASAprepro_lib_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(SEACASAprepro_lib_BUILD_SHARED_LIBS "ON")

set(SEACASAprepro_lib_LINKER /usr/bin/ld)
set(SEACASAprepro_lib_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(SEACASAprepro_lib_INSTALL_DIR "/usr")

## List of package include dirs
set(SEACASAprepro_lib_INCLUDE_DIRS "")

## List of package library paths
set(SEACASAprepro_lib_LIBRARY_DIRS "")

## List of package libraries
set(SEACASAprepro_lib_LIBRARIES "SEACASAprepro_lib::aprepro_lib;SEACASExodus::exodus")

## Specification of directories for TPL headers
set(SEACASAprepro_lib_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(SEACASAprepro_lib_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(SEACASAprepro_lib_TPL_LIBRARIES "Netcdf::all_libs;HDF5::all_libs;Pthread::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(SEACASAprepro_lib_MPI_LIBRARIES "")
set(SEACASAprepro_lib_MPI_LIBRARY_DIRS "")
set(SEACASAprepro_lib_MPI_INCLUDE_DIRS "")
set(SEACASAprepro_lib_MPI_EXEC "")
set(SEACASAprepro_lib_MPI_EXEC_MAX_NUMPROCS "")
set(SEACASAprepro_lib_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(SEACASAprepro_lib_PACKAGE_LIST "SEACASAprepro_lib;SEACASExodus")

## The TPLs enabled for this project
set(SEACASAprepro_lib_TPL_LIST "Netcdf;HDF5;Pthread")

# Enables/Disables for upstream package dependencies
set(SEACASAprepro_lib_ENABLE_SEACASExodus ON)

# Exported cache variables
set(SEACAS_ENABLE_DEBUG "OFF")
set(HAVE_SEACAS_DEBUG "OFF")
set(SEACASExodus_ENABLE_THREADSAFE "OFF")
set(EXODUS_THREADSAFE "OFF")
set(SEACASExodus_ENABLE_STATIC "OFF")
set(EXODUS_STATIC "OFF")
set(SEACASExodus_ENABLE_SHARED "OFF")
set(EXODUS_SHARED "OFF")
set(SEACASIoss_ENABLE_THREADSAFE "OFF")
set(IOSS_THREADSAFE "OFF")

# Include configuration of dependent packages
if (NOT TARGET SEACASExodus::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../SEACASExodus/SEACASExodusConfig.cmake")
endif()

# Import SEACASAprepro_lib targets
include("${CMAKE_CURRENT_LIST_DIR}/SEACASAprepro_libTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(SEACASAprepro_lib_EXPORTED_PACKAGE_LIBS_NAMES "aprepro_lib")

foreach(libname IN LISTS SEACASAprepro_lib_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE SEACASAprepro_lib::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'SEACASAprepro_lib::${libname}', or better yet,"
      " 'SEACASAprepro_lib::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'SEACASAprepro_lib'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'SEACASAprepro_lib_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
