# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/ShyLU_NodeHTS clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "ShyLU_NodeHTS requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/ShyLU_NodeHTS build
## ---------------------------------------------------------------------------

set(ShyLU_NodeHTS_CXX_COMPILER "/usr/bin/g++")

set(ShyLU_NodeHTS_C_COMPILER "/usr/bin/gcc")

set(ShyLU_NodeHTS_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(ShyLU_NodeHTS_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/ShyLU_NodeHTS build
## ---------------------------------------------------------------------------

## Give the build type
set(ShyLU_NodeHTS_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(ShyLU_NodeHTS_CXX_FLAGS [[ ]])

set(ShyLU_NodeHTS_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fPIC -w -fopenmp ]])

set(ShyLU_NodeHTS_Fortran_FLAGS [[ ]])
# Deprecated
set(ShyLU_NodeHTS_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(ShyLU_NodeHTS_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(ShyLU_NodeHTS_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(ShyLU_NodeHTS_BUILD_SHARED_LIBS "ON")

set(ShyLU_NodeHTS_LINKER /usr/bin/ld)
set(ShyLU_NodeHTS_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(ShyLU_NodeHTS_INSTALL_DIR "/usr")

## List of package include dirs
set(ShyLU_NodeHTS_INCLUDE_DIRS "")

## List of package library paths
set(ShyLU_NodeHTS_LIBRARY_DIRS "")

## List of package libraries
set(ShyLU_NodeHTS_LIBRARIES "ShyLU_NodeHTS::shylu_nodehts;KokkosKernels::kokkoskernels;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(ShyLU_NodeHTS_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(ShyLU_NodeHTS_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(ShyLU_NodeHTS_TPL_LIBRARIES "DLlib::all_libs;SuperLU::all_libs;LAPACK::all_libs;BLAS::all_libs;Pthread::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(ShyLU_NodeHTS_MPI_LIBRARIES "")
set(ShyLU_NodeHTS_MPI_LIBRARY_DIRS "")
set(ShyLU_NodeHTS_MPI_INCLUDE_DIRS "")
set(ShyLU_NodeHTS_MPI_EXEC "")
set(ShyLU_NodeHTS_MPI_EXEC_MAX_NUMPROCS "")
set(ShyLU_NodeHTS_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(ShyLU_NodeHTS_PACKAGE_LIST "ShyLU_NodeHTS;KokkosKernels;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(ShyLU_NodeHTS_TPL_LIST "DLlib;SuperLU;LAPACK;BLAS;Pthread")

# Enables/Disables for upstream package dependencies
set(ShyLU_NodeHTS_ENABLE_KokkosKernels ON)
set(ShyLU_NodeHTS_ENABLE_MKL OFF)
set(ShyLU_NodeHTS_ENABLE_BLAS ON)

# Exported cache variables
set(ShyLU_NodeHTS_ENABLE_COMPLEX "ON")
set(HAVE_SHYLU_NODEHTS_COMPLEX "ON")
set(ShyLU_NodeHTS_ENABLE_KOKKOSKERNELS "Trilinos_ENABLE_KokkosKernels")
set(HAVE_SHYLU_NODEHTS_KOKKOSKERNELS "ON")

# Include configuration of dependent packages
if (NOT TARGET KokkosKernels::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosKernels/KokkosKernelsConfig.cmake")
endif()
if (NOT TARGET BLAS::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Trilinos/external_packages/BLAS/BLASConfig.cmake")
endif()

# Import ShyLU_NodeHTS targets
include("${CMAKE_CURRENT_LIST_DIR}/ShyLU_NodeHTSTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(ShyLU_NodeHTS_EXPORTED_PACKAGE_LIBS_NAMES "shylu_nodehts")

foreach(libname IN LISTS ShyLU_NodeHTS_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE ShyLU_NodeHTS::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'ShyLU_NodeHTS::${libname}', or better yet,"
      " 'ShyLU_NodeHTS::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'ShyLU_NodeHTS'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'ShyLU_NodeHTS_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
