# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/Stokhos clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################

if(CMAKE_VERSION VERSION_LESS 3.3)
  set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE
    "Stokhos requires CMake 3.3 or later for 'if (... IN_LIST ...)'"
    )
  set(${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
  return()
endif()
cmake_minimum_required(VERSION 3.3...3.17.0)

## ---------------------------------------------------------------------------
## Compilers used by Trilinos/Stokhos build
## ---------------------------------------------------------------------------

set(Stokhos_CXX_COMPILER "/usr/bin/g++")

set(Stokhos_C_COMPILER "/usr/bin/gcc")

set(Stokhos_Fortran_COMPILER "/usr/bin/gfortran")
# Deprecated!
set(Stokhos_FORTRAN_COMPILER "/usr/bin/gfortran") 


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/Stokhos build
## ---------------------------------------------------------------------------

## Give the build type
set(Stokhos_CMAKE_BUILD_TYPE "Release")

## Set compiler flags, including those determined by build type
set(Stokhos_CXX_FLAGS [[ ]])

set(Stokhos_C_FLAGS [[ -pedantic -Wall -Wno-long-long -std=c99   -O2 -flto=auto -ffat-lto-objects -fexceptions  -grecord-gcc-switches -pipe -Wall  -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS    -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fPIC -w -fopenmp ]])

set(Stokhos_Fortran_FLAGS [[ ]])
# Deprecated
set(Stokhos_FORTRAN_FLAGS [[ ]])

## Extra link flags (e.g., specification of fortran libraries)
set(Stokhos_EXTRA_LD_FLAGS [[]])

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
set(Stokhos_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/usr//usr/lib64")
set(Stokhos_BUILD_SHARED_LIBS "ON")

set(Stokhos_LINKER /usr/bin/ld)
set(Stokhos_AR /usr/bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## Base install location (if not in the build tree)
set(Stokhos_INSTALL_DIR "/usr")

## List of package include dirs
set(Stokhos_INCLUDE_DIRS "")

## List of package library paths
set(Stokhos_LIBRARY_DIRS "")

## List of package libraries
set(Stokhos_LIBRARIES "Stokhos::stokhos_muelu;Stokhos::stokhos_muelu_pce_openmp;Stokhos::stokhos_muelu_mp_16_openmp;Stokhos::stokhos_ifpack2;Stokhos::stokhos_ifpack2_pce_openmp;Stokhos::stokhos_ifpack2_mp_16_openmp;Stokhos::stokhos_amesos2;Stokhos::stokhos_amesos2_mp_16_openmp;Stokhos::stokhos_xpetra;Stokhos::stokhos_xpetra_pce_openmp;Stokhos::stokhos_xpetra_mp_16_openmp;Stokhos::stokhos_tpetra;Stokhos::stokhos_tpetraext_pce_openmp;Stokhos::stokhos_tpetra_pce_openmp;Stokhos::stokhos_tpetra_sd_pce_openmp;Stokhos::stokhos_tpetraext_mp_16_openmp;Stokhos::stokhos_tpetra_mp_16_openmp;Stokhos::stokhos_tpetra_sd_mp_16_openmp;Stokhos::stokhos_sacado;Stokhos::stokhos;MueLu::muelu-adapters;MueLu::muelu;NOX::locatpetra;NOX::locathyra;NOX::locaepetra;NOX::localapack;NOX::loca;NOX::noxepetra;NOX::noxlapack;NOX::nox;Intrepid2::intrepid2;Teko::teko;Stratimikos::stratimikos;Stratimikos::stratimikosbelos;Stratimikos::stratimikosamesos2;Stratimikos::stratimikosaztecoo;Stratimikos::stratimikosamesos;Stratimikos::stratimikosml;Stratimikos::stratimikosifpack;Ifpack2::ifpack2-adapters;Ifpack2::ifpack2;Anasazi::anasazitpetra;Anasazi::ModeLaplace;Anasazi::anasaziepetra;Anasazi::anasazi;Amesos2::amesos2;ShyLU_NodeTacho::tacho;ShyLU_NodeHTS::shylu_nodehts;Belos::belosxpetra;Belos::belostpetra;Belos::belosepetra;Belos::belos;ML::ml;Ifpack::ifpack;Zoltan2Core::zoltan2;Amesos::amesos;Galeri::galeri-xpetra;Galeri::galeri-epetra;AztecOO::aztecoo;Isorropia::isorropia;Xpetra::xpetra-sup;Xpetra::xpetra;ThyraTpetraAdapters::thyratpetra;ThyraEpetraExtAdapters::thyraepetraext;ThyraEpetraAdapters::thyraepetra;ThyraCore::thyracore;TrilinosSS::trilinosss;TpetraCore::tpetraext;TpetraCore::tpetrainout;TpetraCore::tpetra;TpetraCore::tpetraclassic;TpetraTSQR::kokkostsqr;EpetraExt::epetraext;Triutils::triutils;Shards::shards;Zoltan::zoltan;Zoltan::simpi;Epetra::epetra;Sacado::sacado;RTOp::rtop;KokkosKernels::kokkoskernels;TeuchosKokkosComm::teuchoskokkoscomm;TeuchosKokkosCompat::teuchoskokkoscompat;TeuchosRemainder::teuchosremainder;TeuchosNumerics::teuchosnumerics;TeuchosComm::teuchoscomm;TeuchosParameterList::teuchosparameterlist;TeuchosParser::teuchosparser;TeuchosCore::teuchoscore;KokkosSimd::kokkossimd;KokkosAlgorithms::kokkosalgorithms;KokkosContainers::kokkoscontainers;KokkosCore::kokkoscore")

## Specification of directories for TPL headers
set(Stokhos_TPL_INCLUDE_DIRS "")

## Specification of directories for TPL libraries
set(Stokhos_TPL_LIBRARY_DIRS "")

## List of required TPLs
set(Stokhos_TPL_LIBRARIES "DLlib::all_libs;Eigen::all_libs;AMD::all_libs;UMFPACK::all_libs;SuperLU::all_libs;HDF5::all_libs;Zlib::all_libs;Scotch::all_libs;Boost::all_libs;LAPACK::all_libs;BLAS::all_libs;Pthread::all_libs;yaml-cpp::all_libs")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

set(Stokhos_MPI_LIBRARIES "")
set(Stokhos_MPI_LIBRARY_DIRS "")
set(Stokhos_MPI_INCLUDE_DIRS "")
set(Stokhos_MPI_EXEC "")
set(Stokhos_MPI_EXEC_MAX_NUMPROCS "")
set(Stokhos_MPI_EXEC_NUMPROCS_FLAG "")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
set(Stokhos_PACKAGE_LIST "Stokhos;MueLu;NOX;Intrepid2;Teko;Stratimikos;Ifpack2;Anasazi;Amesos2;ShyLU_NodeTacho;ShyLU_NodeHTS;Belos;ML;Ifpack;Zoltan2Core;Amesos;Galeri;AztecOO;Isorropia;Xpetra;Thyra;ThyraTpetraAdapters;ThyraEpetraExtAdapters;ThyraEpetraAdapters;ThyraCore;TrilinosSS;Tpetra;TpetraCore;TpetraTSQR;EpetraExt;Triutils;Shards;Zoltan;Epetra;Sacado;RTOp;KokkosKernels;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosParser;TeuchosCore;Kokkos;KokkosSimd;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
set(Stokhos_TPL_LIST "DLlib;Eigen;AMD;UMFPACK;SuperLU;HDF5;Zlib;Scotch;Boost;LAPACK;BLAS;Pthread;yaml-cpp")

# Enables/Disables for upstream package dependencies
set(Stokhos_ENABLE_Teuchos ON)
set(Stokhos_ENABLE_KokkosCore ON)
set(Stokhos_ENABLE_EpetraExt ON)
set(Stokhos_ENABLE_Ifpack ON)
set(Stokhos_ENABLE_ML ON)
set(Stokhos_ENABLE_TriKota OFF)
set(Stokhos_ENABLE_Anasazi ON)
set(Stokhos_ENABLE_Sacado ON)
set(Stokhos_ENABLE_NOX ON)
set(Stokhos_ENABLE_Isorropia ON)
set(Stokhos_ENABLE_KokkosKernels ON)
set(Stokhos_ENABLE_TeuchosKokkosComm ON)
set(Stokhos_ENABLE_KokkosAlgorithms ON)
set(Stokhos_ENABLE_KokkosContainers ON)
set(Stokhos_ENABLE_Tpetra ON)
set(Stokhos_ENABLE_Ifpack2 ON)
set(Stokhos_ENABLE_MueLu ON)
set(Stokhos_ENABLE_Belos ON)
set(Stokhos_ENABLE_Amesos2 ON)
set(Stokhos_ENABLE_Thyra ON)
set(Stokhos_ENABLE_Xpetra ON)
set(Stokhos_ENABLE_ForUQTK OFF)
set(Stokhos_ENABLE_CUDA OFF)
set(Stokhos_ENABLE_Thrust OFF)
set(Stokhos_ENABLE_Cusp OFF)
set(Stokhos_ENABLE_CUSPARSE OFF)
set(Stokhos_ENABLE_Clp OFF)
set(Stokhos_ENABLE_GLPK OFF)
set(Stokhos_ENABLE_qpOASES OFF)
set(Stokhos_ENABLE_Boost ON)
set(Stokhos_ENABLE_MATLABLib OFF)
set(Stokhos_ENABLE_MKL OFF)

# Exported cache variables
set(Stokhos_ENABLE_EXPLICIT_INSTANTIATION "ON")
set(HAVE_STOKHOS_EXPLICIT_INSTANTIATION "ON")
set(Stokhos_ENABLE_DEBUG "OFF")
set(STOKHOS_DEBUG "OFF")
set(Stokhos_ENABLE_TEUCHOS_TIME_MONITOR "ON")
set(STOKHOS_TEUCHOS_TIME_MONITOR "ON")
set(Stokhos_ENABLE_Experimental "OFF")
set(STOKHOS_EXPERIMENTAL "OFF")
set(Stokhos_ENABLE_Ensemble_Reduction "OFF")
set(HAVE_STOKHOS_ENSEMBLE_REDUCT "OFF")
set(Stokhos_ENABLE_Ensemble_GEMV "ON")
set(HAVE_STOKHOS_ENSEMBLE_GEMV "ON")
set(Stokhos_ENABLE_Ensemble_Scalar_Type "ON")
set(HAVE_STOKHOS_ENSEMBLE_SCALAR_TYPE "ON")
set(Stokhos_ENABLE_PCE_Scalar_Type "ON")
set(HAVE_STOKHOS_PCE_SCALAR_TYPE "ON")
set(Stokhos_ENABLE_OpenMP "ON")
set(HAVE_STOKHOS_OPENMP "ON")

# Include configuration of dependent packages
if (NOT TARGET Teuchos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Teuchos/TeuchosConfig.cmake")
endif()
if (NOT TARGET KokkosCore::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosCore/KokkosCoreConfig.cmake")
endif()
if (NOT TARGET EpetraExt::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../EpetraExt/EpetraExtConfig.cmake")
endif()
if (NOT TARGET Ifpack::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Ifpack/IfpackConfig.cmake")
endif()
if (NOT TARGET ML::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../ML/MLConfig.cmake")
endif()
if (NOT TARGET Anasazi::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Anasazi/AnasaziConfig.cmake")
endif()
if (NOT TARGET Sacado::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Sacado/SacadoConfig.cmake")
endif()
if (NOT TARGET NOX::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../NOX/NOXConfig.cmake")
endif()
if (NOT TARGET Isorropia::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Isorropia/IsorropiaConfig.cmake")
endif()
if (NOT TARGET KokkosKernels::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosKernels/KokkosKernelsConfig.cmake")
endif()
if (NOT TARGET TeuchosKokkosComm::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../TeuchosKokkosComm/TeuchosKokkosCommConfig.cmake")
endif()
if (NOT TARGET KokkosAlgorithms::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosAlgorithms/KokkosAlgorithmsConfig.cmake")
endif()
if (NOT TARGET KokkosContainers::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../KokkosContainers/KokkosContainersConfig.cmake")
endif()
if (NOT TARGET Tpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
endif()
if (NOT TARGET Ifpack2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Ifpack2/Ifpack2Config.cmake")
endif()
if (NOT TARGET MueLu::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../MueLu/MueLuConfig.cmake")
endif()
if (NOT TARGET Belos::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Belos/BelosConfig.cmake")
endif()
if (NOT TARGET Amesos2::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Amesos2/Amesos2Config.cmake")
endif()
if (NOT TARGET Thyra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Thyra/ThyraConfig.cmake")
endif()
if (NOT TARGET Xpetra::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Xpetra/XpetraConfig.cmake")
endif()
if (NOT TARGET Boost::all_libs)
  include("${CMAKE_CURRENT_LIST_DIR}/../Trilinos/external_packages/Boost/BoostConfig.cmake")
endif()

# Import Stokhos targets
include("${CMAKE_CURRENT_LIST_DIR}/StokhosTargets.cmake")

## ----------------------------------------------------------------------------
## Create deprecated non-namespaced library targets for backwards compatibility
## ----------------------------------------------------------------------------

set(Stokhos_EXPORTED_PACKAGE_LIBS_NAMES "stokhos;stokhos_sacado;stokhos_tpetra_sd_mp_16_openmp;stokhos_tpetra_mp_16_openmp;stokhos_tpetraext_mp_16_openmp;stokhos_tpetra_sd_pce_openmp;stokhos_tpetra_pce_openmp;stokhos_tpetraext_pce_openmp;stokhos_tpetra;stokhos_xpetra_mp_16_openmp;stokhos_xpetra_pce_openmp;stokhos_xpetra;stokhos_amesos2_mp_16_openmp;stokhos_amesos2;stokhos_ifpack2_mp_16_openmp;stokhos_ifpack2_pce_openmp;stokhos_ifpack2;stokhos_muelu_mp_16_openmp;stokhos_muelu_pce_openmp;stokhos_muelu")

foreach(libname IN LISTS Stokhos_EXPORTED_PACKAGE_LIBS_NAMES)
  if (NOT TARGET ${libname})
    add_library(${libname} INTERFACE IMPORTED)
    target_link_libraries(${libname}
       INTERFACE Stokhos::${libname})
    set(deprecationMessage
      "WARNING: The non-namespaced target '${libname}' is deprecated!"
      "  If always using newer versions of the project 'Trilinos', then use the"
      " new namespaced target 'Stokhos::${libname}', or better yet,"
      " 'Stokhos::all_libs' to be less sensitive to changes in the definition"
      " of targets in the package 'Stokhos'.  Or, to maintain compatibility with"
      " older or newer versions the project 'Trilinos', instead link against the"
      " libraries specified by the variable 'Stokhos_LIBRARIES'."
      )
    string(REPLACE ";" "" deprecationMessage "${deprecationMessage}")
    set_target_properties(${libname}
      PROPERTIES DEPRECATION "${deprecationMessage}" )
  endif()
endforeach()
